
from twisted.python import log
from twisted.spread import pb
from twisted.internet import defer

import os

import ft

# Remote Interface to the session operations available.
class ServerSession(pb.Viewable):
    pass

# ServerSessionMixin for Filetransfers.
class FileSSM:

    # Receive from a remote Pagerizer, and hand data to collector.
    def view_receivefile(perspective, dummy, pagerizer, local):
        ft.pages_collect(pagerizer, ft.PrintCollector()) # XXX: FileCollector

    # Give the remote End a Pagerizer to read from.
    def view_pagerize(perspective, dummy, filename):
        return ft.FilePagerizer(filename)

# ClientSession wraps the deferred received when requesting a ViewPoint on
# ServerSession, and uses it to chain jobs.

class ClientSession:
    def __init__(self, defr):
        self.defr = defr

# Mixins
class FileCSM:
    def getfile(self, remote, local): # XXX: FileCollector
        self.defr.addCallback(ft.getfile, remote, ft.PrintCollector())

    def sendfile(self, local, remote):
        self.defr.addCallback(ft.sendfile, local, remote)

class CallableCSM:
    def call(self, func, *args, **kws):
        self.defr.addCallback(func, *args, **kws)
