#!/usr/bin/python2

from twisted.spread import pb
from twisted.internet import app, reactor

from twisted.cred import authorizer, identity

from sam import ft

class SamService(pb.Service):
    def getPerspectiveNamed(self, name):
        p = ft.FilePerspective(name)
        p.setService(self)
        return p

appl = app.Application("samd")
auth = authorizer.DefaultAuthorizer()
auth.setApplication(appl)

ident = identity.Identity("guest", authorizer=auth)
ident.setPassword("secret")

svc = SamService("sam", appl, authorizer=auth)
ident.addKeyForPerspective(svc.getPerspectiveNamed("filetransfer"))
auth.addIdentity(ident)

appl.listenTCP(pb.portno, pb.BrokerFactory(pb.AuthRoot(auth)))

appl.run(0)

